#include<bits/stdc++.h>
using namespace std;
long long tochki[10000005];
int main(){
long long n;
long long nachalo=-1,krai=-1;
long long koord[50005][2];
cin>>n;
for(long long i=0;i<n;i++){
    cin>>koord[i][0]>>koord[i][1];
    if(i==0){
        nachalo=koord[i][0];
        krai=koord[i][1];
    }else{
        if(nachalo>koord[i][0]){
            nachalo=koord[i][0];
        }
        if(krai<koord[i][1]){
            krai=koord[i][1];
        }
    }
    for(long long j=koord[i][0];j<koord[i][1];j++){
        tochki[j]++;
    }
}
sort(tochki,tochki+krai-nachalo);
reverse(tochki,tochki+krai-nachalo);
//cout<<krai-nachalo<<endl<<endl;
long long YesNo=0;
long long br=0;
cout<<tochki[0]<<endl;
for(long long i=0;i<krai-nachalo;i++){
    if(tochki[i]==tochki[i-1]){
        br++;
    }else{
        YesNo=1;
    }
}
cout<<br<<endl;
return 0;
}